<?php

namespace App\Providers\Filament;

use App\Filament\Pages\CustomLogin;
use App\Filament\Pages\CustomRegistration;
use BezhanSalleh\FilamentShield\FilamentShieldPlugin;
use Filament\Http\Middleware\Authenticate;
use Filament\Http\Middleware\AuthenticateSession;
use Filament\Http\Middleware\DisableBladeIconComponents;
use Filament\Http\Middleware\DispatchServingFilamentEvent;
use Filament\Pages\Dashboard;
use Filament\Panel;
use Filament\PanelProvider;
use Filament\Support\Colors\Color;
use Filament\Support\Enums\Width;
use Filament\Widgets\AccountWidget;
use Filament\Widgets\FilamentInfoWidget;
use Illuminate\Cookie\Middleware\AddQueuedCookiesToResponse;
use Illuminate\Cookie\Middleware\EncryptCookies;
use Illuminate\Foundation\Http\Middleware\VerifyCsrfToken;
use Illuminate\Routing\Middleware\SubstituteBindings;
use Illuminate\Session\Middleware\StartSession;
use Illuminate\View\Middleware\ShareErrorsFromSession;
use Swis\Filament\Backgrounds\FilamentBackgroundsPlugin;
use Swis\Filament\Backgrounds\ImageProviders\MyImages;

class DashboardPanelProvider extends PanelProvider
{
    public function panel(Panel $panel): Panel
    {
        $directoryAuthBg = 'auth-bg';
        $fullPath = storage_path("app/public/{$directoryAuthBg}");

        if (! is_dir($fullPath)) {
            mkdir($fullPath, 0777, true);
        }

        $files = glob($fullPath.'/*');
        if (! $files || count($files) === 0) {
            $defaultImage = public_path('assets/img/bg/default.jpg');
            $targetImage = $fullPath.'/default.png';
            copy($defaultImage, $targetImage);
        }

        return $panel
            ->default()
            ->id('dashboard')
            ->path('dashboard')
            ->login(CustomLogin::class)
            ->registration(CustomRegistration::class)
            ->emailVerification()
            ->colors([
                'primary' => Color::Blue,
            ])
            ->breadcrumbs(false)
            ->maxContentWidth(Width::Full)
            ->discoverResources(in: app_path('Filament/Resources'), for: 'App\Filament\Resources')
            ->discoverPages(in: app_path('Filament/Pages'), for: 'App\Filament\Pages')
            ->pages([
                Dashboard::class,
            ])
            ->discoverWidgets(in: app_path('Filament/Widgets'), for: 'App\Filament\Widgets')
            ->widgets([
                AccountWidget::class,
                FilamentInfoWidget::class,
            ])
            ->middleware([
                EncryptCookies::class,
                AddQueuedCookiesToResponse::class,
                StartSession::class,
                AuthenticateSession::class,
                ShareErrorsFromSession::class,
                VerifyCsrfToken::class,
                SubstituteBindings::class,
                DisableBladeIconComponents::class,
                DispatchServingFilamentEvent::class,
            ])
            ->plugins([
                FilamentShieldPlugin::make()
                    ->navigationSort(999)
                    ->globallySearchable(false),

                FilamentBackgroundsPlugin::make()
                    ->imageProvider(
                        MyImages::make()
                            ->directory('storage/'.$directoryAuthBg)
                    ),
            ])
            ->authMiddleware([
                Authenticate::class,
            ])
            ->databaseTransactions()
            ->viteTheme('resources/css/filament/dashboard/theme.css')
            ->navigationGroups([
                'Master',
                'Kelola',
                'Monitoring',
                'Publikasi',
                'Pengaturan',
                'Pelindung',
            ]);
    }
}
